/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ cwPaymentForm)
});

;// CONCATENATED MODULE: ./src/ts/utils.ts
class Utils {
    static url(url, data) {
        const parts = url.split("?");
        const urlPart = parts.shift();
        const parameters = {};
        let queryParts = parts
            .join("?")
            .split("&")
            .filter(part => part);
        for (let i = 0; i < queryParts.length; i++) {
            const parameterParts = queryParts[i].split("=");
            parameters[parameterParts[0]] = parameterParts[1];
        }
        for (let parameterName in data) {
            if (data.hasOwnProperty(parameterName)) {
                const parameterValue = data[parameterName];
                parameters[parameterName] = encodeURIComponent(parameterValue);
            }
        }
        queryParts = [];
        for (let parameterName in parameters) {
            if (parameters.hasOwnProperty(parameterName)) {
                const parameterValue = parameters[parameterName];
                queryParts.push(parameterName + "=" + parameterValue);
            }
        }
        return urlPart + "?" + queryParts.join("&");
    }
    static fireEvent(element, eventType) {
        const event = document.createEvent("HTMLEvents");
        event.initEvent(eventType, true, false);
        element.dispatchEvent(event);
    }
    static getParameterByName(name, url) {
        if (!url) {
            url = window.location.href;
        }
        name = name.replace(/[\[\]]/g, "\\$&");
        const regexp = new RegExp(`[?&]${name}(=([^&#]*)|&|#|$)`);
        const results = regexp.exec(url);
        if (!results) {
            return null;
        }
        if (!results[2]) {
            return "";
        }
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    }
    static getUserLanguage() {
        return (navigator.languages && navigator.languages[0]) || navigator.language || navigator["userLanguage"];
    }
    static guidNoDashes() {
        return "xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(/[xy]/g, (symbol) => {
            const randomByte = new Uint8Array(1);
            (window.crypto || window["msCrypto"]).getRandomValues(randomByte);
            const randomFour = randomByte[0] >> 4;
            const hex = symbol === "x" ? randomFour : (randomFour & 0x3) | 0x8;
            return hex.toString(16);
        });
    }
    static detectBrowser(userAgent) {
        const browserRxs = {
            edge: /(edge)[ \/]([\w.]+)/i,
            webkit: /(chrome|crios)[ \/]([\w.]+)/i,
            safari: /(webkit)[ \/]([\w.]+)/i,
            opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i,
            msie: /(msie\s|trident.*? rv:)([\w.]+)/i,
            mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        let agent = undefined;
        for (let a in browserRxs) {
            if (browserRxs.hasOwnProperty(a) && userAgent.match(browserRxs[a])) {
                agent = a;
                break;
            }
        }
        return agent;
    }
    static saveFile(base64Content, fileName, mimeType) {
        // The one and only way of getting global scope in all environments
        // https://stackoverflow.com/q/3277182/1008999
        const globalWindow = typeof window === "object" && window.window === window ? window : typeof self === "object" && self.self === self ? self : __webpack_require__.g;
        const binaryString = window.atob(base64Content);
        const length = binaryString.length;
        const bytes = new Uint8Array(length);
        for (let i = 0; i < length; ++i) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        const blob = new Blob([bytes.buffer], { type: mimeType });
        if ("download" in HTMLAnchorElement.prototype) {
            const a = document.createElement("a");
            a.download = fileName;
            a.rel = "noopener";
            a.href = URL.createObjectURL(blob);
            setTimeout(() => {
                URL.revokeObjectURL(a.href);
            }, 4e4); // 40s
            setTimeout(() => {
                try {
                    a.dispatchEvent(new MouseEvent("click"));
                }
                catch (e) {
                    const event = new MouseEvent("click", {
                        bubbles: true,
                        cancelable: true,
                        view: window,
                        detail: 0,
                        screenX: 0,
                        screenY: 0,
                        clientX: 80,
                        clientY: 20,
                        ctrlKey: false,
                        altKey: false,
                        shiftKey: false,
                        metaKey: false,
                        button: 0,
                        relatedTarget: null
                    });
                    a.dispatchEvent(event);
                }
            }, 0);
            return;
        }
        if ("msSaveOrOpenBlob" in navigator) {
            navigator["msSaveOrOpenBlob"](blob, fileName);
            return;
        }
        // Fallback to using FileReader and a popup
        // Open a popup immediately do go around popup blocker
        // Mostly only available on user interaction and the fileReader is async so...
        let popup = open("", "_blank");
        if (popup) {
            popup.document.title = popup.document.body.innerText = "downloading...";
        }
        const force = blob.type === "application/octet-stream";
        // @ts-ignore
        const isSafari = /constructor/i.test(globalWindow.HTMLElement) || globalWindow.safari;
        const isChromeIOS = /CriOS\/[\d]+/.test(navigator.userAgent);
        if ((isChromeIOS || (force && isSafari)) && typeof window.FileReader === "object") {
            // Safari doesn't allow downloading of blob URLs
            const reader = new FileReader();
            reader.onloadend = () => {
                let url = reader.result;
                url = isChromeIOS ? url : url.replace(/^data:[^;]*;/, "data:attachment/file;");
                if (popup) {
                    popup.location.href = url;
                }
                else {
                    location.href = url;
                }
                popup = null; // reverse-tabnabbing
            };
            reader.readAsDataURL(blob);
        }
        else {
            const url = URL.createObjectURL(blob);
            if (popup) {
                popup.location.href = url;
            }
            else {
                location.href = url;
            }
            popup = null; // reverse-tabnabbing #460
            setTimeout(() => {
                URL.revokeObjectURL(url);
            }, 4e4); // 40s
        }
    }
    static validateStringForRestrictedSymbols(str) {
        return str.match(/^[^%\{\[\]\}\$€ÄäÖöÜüß§\?@\&\#\^\<\>]*$/);
    }
    static format(fmt, valuesArray) {
        return fmt.replace(/\{(\d+)(:[^\}]+)?\}/g, (match, number) => (typeof valuesArray[number] !== "undefined" ? valuesArray[number] : match));
    }
    static isUrl(value) {
        // https://gist.github.com/dperini/729294
        const regex = "^(?:https://)(?:\\S+(?::\\S*)?@)?(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))?)(?::\\d{2,5})?(?:[/?#]\\S*)?$";
        const pattern = new RegExp(regex, "i");
        return typeof value === "string" && pattern.exec(value);
    }
}

;// CONCATENATED MODULE: ./src/ts/api-helper.ts

class ApiHelper {
    constructor(options) {
        this._options = options;
    }
    get(relativeUrl, urlData) {
        return this._send("GET", relativeUrl, urlData);
    }
    post(relativeUrl, urlData, bodyData) {
        return this._send("POST", relativeUrl, urlData, bodyData);
    }
    put(relativeUrl, urlData, bodyData) {
        return this._send("PUT", relativeUrl, urlData, bodyData);
    }
    delete(relativeUrl, urlData, bodyData) {
        return this._send("DELETE", relativeUrl, urlData, bodyData);
    }
    createRequestObject(data) {
        const now = new Date();
        return {
            ...data,
            ...{
                partnerReference: `WSDK-${Utils.guidNoDashes()}`,
                localDate: this._pad(now.getFullYear(), 4) + "-" + this._pad(now.getMonth() + 1, 2) + "-" + this._pad(now.getDate(), 2),
                localTime: this._pad(now.getHours(), 2) + this._pad(now.getMinutes(), 2) + this._pad(now.getSeconds(), 2)
            }
        };
    }
    _send(method, relativeUrl, urlData, bodyData) {
        if (!this._options.getApiURL()) {
            throw new Error("API URL is not set. Use cw.initialize method to initialize SDK.");
        }
        let callbacks;
        const result = {
            complete(c) {
                callbacks = c;
            }
        };
        const xhttp = new XMLHttpRequest();
        xhttp.onreadystatechange = function () {
            if (this.readyState !== 4) {
                return;
            }
            switch (this.status) {
                case 200:
                    if (callbacks && typeof callbacks.success === "function") {
                        const responseObject = JSON.parse(this.responseText);
                        callbacks.success(responseObject);
                    }
                    break;
                default:
                    if (callbacks && typeof callbacks.error === "function") {
                        let errorData;
                        const contentTypeHeader = this.getResponseHeader("Content-Type");
                        if (contentTypeHeader && contentTypeHeader.toLowerCase().indexOf("application/json") !== -1) {
                            errorData = JSON.parse(this.responseText);
                        }
                        else {
                            errorData = {
                                responseDescription: this.responseText
                            };
                        }
                        callbacks.error(errorData);
                    }
                    break;
            }
        };
        xhttp.open(method, Utils.url(this._options.getApiURL() + relativeUrl, urlData), true);
        xhttp.setRequestHeader("Content-Type", "application/json");
        xhttp.send(!!bodyData ? JSON.stringify(bodyData) : null);
        return result;
    }
    _pad(num, len) {
        let str = num.toString();
        while (str.length < len) {
            str = `0${str}`;
        }
        return str;
    }
}

;// CONCATENATED MODULE: ./src/ts/global-options.ts

class GlobalOptions {
    constructor(l10n) {
        this._supportedPaymentOptionCodes = [
            "MSTRCRD",
            "VISA",
            "VISADBIT",
            "MSTRO",
            "AMEX",
            "CRTBANCAIR",
            "PAYPAL",
            "GIROPAY",
            "IDEAL",
            "BNKACCT",
            "PAYU",
            "PAYUBLK",
            "PAYUTWST",
            "PAYUINST",
            "DISCOVER",
            "JCB",
            "VISAELTRN"
        ];
        this._supportedPaymentProviderPaymentOptions = [];
        this._initializationOptions = {
            apiURL: null,
            locale: null
        };
        this._l10n = l10n;
        this._addProvider("PAYON", ["MSTRCRD", "VISA", "VISADBIT", "MSTRO", "AMEX", "CRTBANCAIR", "PAYPAL", "GIROPAY", "IDEAL", "BNKACCT", "JCB"]);
        this._addProvider("PAYMENTSOS", ["PAYU", "PAYUBLK", "PAYUTWST", "PAYUINST"]);
    }
    update(options) {
        if (options.apiURL && !Utils.isUrl(options.apiURL)) {
            throw new Error("The ApiURL must be valid");
        }
        if (options.apiURL && options.apiURL.substring(options.apiURL.length - 1) !== "/") {
            options.apiURL += "/";
        }
        this._initializationOptions = {
            ...this._initializationOptions,
            ...options
        };
        const locale = options.locale || this._initializationOptions.locale;
        if (locale) {
            this._l10n.locale(locale);
        }
        if (options.cardPaymentProvider) {
            switch (options.cardPaymentProvider.toLowerCase()) {
                case "cybersourcewithtokenex":
                    this._addProvider("CYBERSOURCEWITHTOKENEX", ["MSTRCRD", "VISA", "AMEX", "DISCOVER", "JCB"]);
                    break;
                case "vestawithtokenex":
                    this._addProvider("VESTAWITHTOKENEX", ["MSTRCRD", "VISA", "AMEX", "DISCOVER"]);
                    break;
                case "payonwithpciproxy":
                    this._addProvider("PAYONWITHPCIPROXY", ["MSTRCRD", "VISA", "VISADBIT", "MSTRO", "AMEX", "JCB"]);
                    break;
            }
            if (options.cardPaymentProvider.toLowerCase() === "cybersource" || options.enableCyberSource) {
                this._addProvider("CYBERSOURCE", ["MSTRCRD", "VISA", "MSTRO", "AMEX", "DISCOVER", "VISAELTRN"]);
            }
        }
        if (options.enablePayPal) {
            this._addProvider("PAYPAL", ["PAYPAL"]);
        }
        if (options.bankAccountPaymentProvider && options.bankAccountPaymentProvider.toLowerCase() === "sepa") {
            this._addProvider("SEPA", ["BNKACCT"]);
        }
    }
    getApiURL() {
        return this._initializationOptions.apiURL;
    }
    getSupportedPaymentProviderPaymentOptions() {
        return this._supportedPaymentProviderPaymentOptions;
    }
    validatePaymentOptionCodesSupported(paymentOptionCodes) {
        const filteredPaymentOptionCodes = paymentOptionCodes.filter(paymentOptionCode => this._supportedPaymentOptionCodes.indexOf(paymentOptionCode) !== -1);
        if (filteredPaymentOptionCodes.length !== paymentOptionCodes.length) {
            throw new Error("The 'paymentOptionCodes' collection contains unsupported payment option codes.");
        }
    }
    resolvePaymentProvider(paymentOptionCodes) {
        const supportedProvider = this._supportedPaymentProviderPaymentOptions.find(x => {
            return paymentOptionCodes.some(poc => x.paymentOptionCodes.includes(poc));
        });
        return (supportedProvider && supportedProvider.code) || undefined;
    }
    _addProvider(code, paymentOptionCodes) {
        this._supportedPaymentProviderPaymentOptions.unshift({
            code: code,
            paymentOptionCodes: paymentOptionCodes
        });
    }
}

;// CONCATENATED MODULE: ./src/ts/l10n.ts

class L10n {
    constructor() {
        this._cultures = {
            en: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN does not belong to a SEPA country",
                    payment_form_invalid_account_holder: "Invalid account holder",
                    validation_msg_card_holder: "Please enter your name exactly as it appears on your credit card",
                    payment_form_store_payment_method: "Store payment method?",
                    user_agreement_accept_button: "Accept",
                    user_agreement_widget_mode1_btn_close: "Agree and Create Account",
                    user_agreement_widget_mode_btn_back: "Back",
                    user_agreement_widget_lnk_download: "Download Terms and Conditions",
                    aspo_newcard_txt_card_number: "Card Number",
                    aspo_newcard_txt_expiry_date: "Expiry Date",
                    aspo_newcard_txt_card_holder: "Card Holder",
                    aspo_newcard_txt_cvv: "CVV",
                    aspo_newcard_txt_acc_holder: "Account Holder",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "It is required that you agree to the terms and conditions of {0}. Please review the terms and conditions and check the checkbox that you agree with them.",
                    user_agreement_widget_mode_chb_agree: "I am of legal age, have read, saved and agree to the Terms and Conditions and Privacy Policy of {0}.",
                    payment_cybersource_btn_pay: "Pay",
                    validation_msg_invalid: "Invalid '{0}'.",
                    validation_msg_card_cvv: "Invalid CVV"
                }
            },
            "en-CA": {
                strings: {
                    payment_form_invalid_iban_country: "IBAN does not belong to a SEPA country",
                    payment_form_invalid_account_holder: "Invalid account holder",
                    validation_msg_card_holder: "Please enter your name exactly as it appears on your credit card",
                    payment_form_store_payment_method: "Store Payment Method?",
                    user_agreement_accept_button: "Accept",
                    user_agreement_widget_mode1_btn_close: "Agree and Create Account",
                    user_agreement_widget_mode_btn_back: "Back",
                    user_agreement_widget_lnk_download: "Download Terms and Conditions",
                    aspo_newcard_txt_card_number: "Card Number",
                    aspo_newcard_txt_expiry_date: "Expiry Date",
                    aspo_newcard_txt_card_holder: "Card Holder",
                    aspo_newcard_txt_cvv: "CVV",
                    aspo_newcard_txt_acc_holder: "Account Holder",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "It is required that you agree to the terms and conditions of {0}. Please review the terms and conditions and check the checkbox that you agree with them.",
                    user_agreement_widget_mode_chb_agree: "I am of legal age, have read, saved and agree to the Terms and Conditions and Privacy Policy of {0}.",
                    payment_cybersource_btn_pay: "Pay",
                    validation_msg_invalid: "Invalid '{0}'.",
                    validation_msg_card_cvv: "Invalid CVV"
                }
            },
            "cs-CZ": {
                strings: {
                    aspo_newcard_txt_cvv_holder: "CVC/CVV kód",
                    aspo_newcard_txt_expiry_date_holder: "MM / RR"
                }
            },
            de: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN gehört nicht zu einem Land der SEPA-Liste",
                    payment_form_invalid_account_holder: "Ungültiger Kontoinhaber",
                    validation_msg_card_holder: "Bitte geben Sie Ihren Namen genau so ein, wie er auf Ihrer Kreditkarte steht",
                    payment_form_store_payment_method: "Zahlungsart speichern?",
                    user_agreement_accept_button: "Zustimmen",
                    user_agreement_widget_mode1_btn_close: "Zustimmen und Konto eröffnen",
                    user_agreement_widget_mode_btn_back: "Zurück",
                    user_agreement_widget_lnk_download: "Allgemeine Geschäftsbedingungen herunterladen",
                    aspo_newcard_txt_card_number: "Kartennummer",
                    aspo_newcard_txt_expiry_date: "Ablaufdatum",
                    aspo_newcard_txt_card_holder: "Karteninhaber",
                    aspo_newcard_txt_cvv: "Kartenprüfnummer",
                    aspo_newcard_txt_acc_holder: "Kontoinhaber",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "Es ist erforderlich, dass Sie den Allgemeinen Geschäftsbedinungen von {0} zustimmen. Bitte überprüfen Sie die Allgemeinen Geschäftsbedingungen und bestätigen Sie, dass Sie einverstanden sind, indem Sie das Häkchen im Kontrollkästchen setzen. ",
                    user_agreement_widget_mode_chb_agree: "Ich bin volljährig und habe die Allgemeinen Geschäftsbedingungen und die Datenschutzerklärung von {0} gelesen, gespeichert und akzeptiert.",
                    payment_cybersource_btn_pay: "Bezahlen",
                    validation_msg_invalid: "'{0}' ist ungültig.",
                    validation_msg_card_cvv: "Ungültige Kartenprüfnummer"
                }
            },
            el: {
                strings: {
                    payment_form_invalid_iban_country: "Το ΙΒΑΝ δεν ανήκει σε χώρα του SEPA",
                    payment_form_invalid_account_holder: "Παρακαλώ εισάγετε μια τιμή για κάτοχος λογαριασμού",
                    validation_msg_card_holder: "Παρακαλώ εισάγετε μια τιμή για κάτοχο της κάρτας",
                    payment_form_store_payment_method: "Να αποθηκευτεί η μέθοδος πληρωμών?"
                }
            },
            es: {
                strings: {
                    payment_form_invalid_iban_country: "El IBAN no pertenece a un país SEPA",
                    payment_form_invalid_account_holder: "Titular de la cuenta no válido",
                    validation_msg_card_holder: "Introduzca su nombre exactamente como aparece en su tarjeta de crédito",
                    payment_form_store_payment_method: "¿Guardar el método de pago?",
                    user_agreement_accept_button: "Aceptar",
                    user_agreement_widget_mode1_btn_close: "Aceptar y abrir cuenta",
                    user_agreement_widget_mode_btn_back: "Atrás",
                    user_agreement_widget_lnk_download: "Descargar los términos y condiciones",
                    aspo_newcard_txt_card_number: "Número de tarjeta",
                    aspo_newcard_txt_expiry_date: "Fecha de expiración",
                    aspo_newcard_txt_card_holder: "Titular de la tarjeta",
                    aspo_newcard_txt_cvv: "Código de seguridad",
                    aspo_newcard_txt_acc_holder: "Titular de la cuenta",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "Es necesario que acepte los términos y condiciones de {0}. Por favor, revise los términos y condiciones y marque la casilla de verificación si está de acuerdo con ellos.",
                    user_agreement_widget_mode_chb_agree: "Soy mayor de edad, he leído, guardado y acepto los Términos y Condiciones y la Política de Privacidad de {0}.",
                    payment_cybersource_btn_pay: "Pagar",
                    validation_msg_invalid: "'{0}' no válido.",
                    validation_msg_card_cvv: "Código de seguridad de la tarjeta no válido"
                }
            },
            et: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN ei kuulu SEPA riigile",
                    payment_form_invalid_account_holder: "Kehtetu konto omanik",
                    validation_msg_card_holder: "Kehtetu kaardi omanik",
                    payment_form_store_payment_method: "Salvestada makseviis?"
                }
            },
            fi: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN ei ole SEPA-alueen tilinumero",
                    payment_form_invalid_account_holder: "Virheellinen tilin haltijan",
                    validation_msg_card_holder: "Virheellinen kortin haltija",
                    payment_form_store_payment_method: "Tallennetaanko maksutapa?"
                }
            },
            fr: {
                strings: {
                    payment_form_invalid_iban_country: "L'IBAN ne correspond à aucun pays de la procédure SEPA",
                    payment_form_invalid_account_holder: "Titulaire de compte invalide",
                    validation_msg_card_holder: "Veuillez spécifier le nom exact tel qu’écrit sur votre carte de crédit",
                    payment_form_store_payment_method: "Stocker les méthodes de payement ?",
                    user_agreement_accept_button: "Accepter",
                    user_agreement_widget_mode1_btn_close: "J’accepte et crée un compte",
                    user_agreement_widget_mode_btn_back: "Précédent",
                    user_agreement_widget_lnk_download: "Télécharger les Conditions générales d’utilisation",
                    aspo_newcard_txt_card_number: "Numéro de carte",
                    aspo_newcard_txt_expiry_date: "Date d'expiration",
                    aspo_newcard_txt_card_holder: "Titulaire de la carte",
                    aspo_newcard_txt_cvv: "CVV",
                    aspo_newcard_txt_acc_holder: "Titulaire de compte",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "Vous devez accepter les Conditions générales d’utilisation de {0}. Veuillez consulter les Conditions générales d’utilisation et cocher la case indiquant que vous les acceptez.",
                    user_agreement_widget_mode_chb_agree: "Je suis majeur, j'ai lu, enregistré et accepté les Conditions générales d’utilisation et la Déclaration de confidentialité de {0}.",
                    payment_cybersource_btn_pay: "Payer",
                    validation_msg_invalid: "« {0} » non valide.",
                    validation_msg_card_cvv: "Code de sécurité de la carte non valide"
                }
            },
            "fr-CA": {
                strings: {
                    payment_form_invalid_iban_country: "L'IBAN ne correspond à aucun pays de la procédure SEPA",
                    payment_form_invalid_account_holder: "Titulaire de compte invalide",
                    validation_msg_card_holder: "Veuillez spécifier le nom exact tel qu’écrit sur votre carte de crédit",
                    payment_form_store_payment_method: "Mémoriser le mode de paiement ?",
                    user_agreement_accept_button: "Accepter",
                    user_agreement_widget_mode1_btn_close: "J’accepte et crée un compte",
                    user_agreement_widget_mode_btn_back: "Précédent",
                    user_agreement_widget_lnk_download: "Télécharger les Conditions générales d’utilisation",
                    aspo_newcard_txt_card_number: "Numéro de carte",
                    aspo_newcard_txt_expiry_date: "Date d'expiration",
                    aspo_newcard_txt_card_holder: "Titulaire de la carte",
                    aspo_newcard_txt_cvv: "CVV",
                    aspo_newcard_txt_acc_holder: "Titulaire de compte",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "Vous devez accepter les Conditions générales d’utilisation de {0}. Veuillez consulter les Conditions générales d’utilisation et cocher la case indiquant que vous les acceptez.",
                    user_agreement_widget_mode_chb_agree: "Je suis majeur, j'ai lu, enregistré et accepté les Conditions générales d’utilisation et la Déclaration de confidentialité de {0}.",
                    payment_cybersource_btn_pay: "Payer",
                    validation_msg_invalid: "« {0} » non valide.",
                    validation_msg_card_cvv: "Code de sécurité de la carte non valide"
                }
            },
            it: {
                strings: {
                    payment_form_invalid_iban_country: "L’IBAN non appartiene a un paese del circuito SEPA",
                    payment_form_invalid_account_holder: "Titolare del Conto non valida",
                    validation_msg_card_holder: "Inserisca il Suo nome esattamente come riportato sulla Sua carta di credito",
                    payment_form_store_payment_method: "Salvare metodo di pagamento?",
                    user_agreement_accept_button: "Accetta",
                    user_agreement_widget_mode1_btn_close: "Accettare e creare conto",
                    user_agreement_widget_mode_btn_back: "Indietro",
                    user_agreement_widget_lnk_download: "Scaricare le condizioni generali di contratto",
                    aspo_newcard_txt_card_number: "Numero carta",
                    aspo_newcard_txt_expiry_date: "Data di scadenza",
                    aspo_newcard_txt_card_holder: "Titolare della carta",
                    aspo_newcard_txt_cvv: "CVV",
                    aspo_newcard_txt_acc_holder: "Titolare del Conto",
                    aspo_newcard_txt_iban: "IBAN",
                    user_agreement_widget_agree_err_txt: "Deve accettare le condizioni generali di contratto di {0}. La preghiamo di esaminare le condizioni generali di contratto e di spuntare la casella di controllo per accettarli.",
                    user_agreement_widget_mode_chb_agree: "Sono maggiorenne; ho letto, salvato e accettato le condizioni generali di contratto e l'informativa sulla privacy di {0}.",
                    payment_cybersource_btn_pay: "Pagare",
                    validation_msg_invalid: "'{0}' non valido.",
                    validation_msg_card_cvv: "Codice di sicurezza della carta non valido"
                }
            },
            lt: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN nepriklauso SEPA šaliai",
                    payment_form_invalid_account_holder: "Neteisingas sąskaitos turėtojas",
                    validation_msg_card_holder: "Neteisingas sąskaitos turėtojas",
                    payment_form_store_payment_method: "Išsaugoti mokėjimo būdą?"
                }
            },
            lv: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN nepieder SEPA valstij",
                    payment_form_invalid_account_holder: "Neatbilstošs konta turētājs",
                    validation_msg_card_holder: "Neatbilstošs kartes turētājs",
                    payment_form_store_payment_method: "Saglabāt maksājuma veidu?"
                }
            },
            nl: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN hoort niet bij een SEPA-land",
                    payment_form_invalid_account_holder: "Ongeldig eigenaar",
                    validation_msg_card_holder: "Ongeldige kaarthouder",
                    payment_form_store_payment_method: "Betalingsmethode opslaan?"
                }
            },
            pt: {
                strings: {
                    payment_form_invalid_iban_country: "O IBAN não pertence a um país SEPA",
                    payment_form_invalid_account_holder: "Por favor insira um valor para o Titular da conta",
                    validation_msg_card_holder: "Por favor insira um valor para o Titular do cartão",
                    payment_form_store_payment_method: "Guardar método de pagamento?"
                }
            },
            sk: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN neprináleží žiadnej krajine SEPA",
                    payment_form_invalid_account_holder: "Zadajte prosím hodnotu Majiteľ účtu",
                    validation_msg_card_holder: "Zadajte prosím hodnotu Držiteľ karty",
                    payment_form_store_payment_method: "Uložiť platobnú metódu?"
                }
            },
            sl: {
                strings: {
                    payment_form_invalid_iban_country: "IBAN ne pripada državi SEPA",
                    payment_form_invalid_account_holder: "Vnesite vrednosti za Ime lastnika",
                    validation_msg_card_holder: "Vnesite vrednosti za Ime lastnika",
                    payment_form_store_payment_method: "Shrani način plačila?"
                }
            }
        };
        this._fallbackCulture = "en";
    }
    locale(locale) {
        if (locale !== undefined) {
            this._locale = locale;
        }
        else {
            return this._locale;
        }
    }
    localeOrDefault() {
        return this._locale || Utils.getUserLanguage() || "en-US";
    }
    getCulture() {
        return this.localeOrDefault().split("-")[0];
    }
    translate(key, fallback) {
        if (!key) {
            throw new Error("Localization string key is not defined.");
        }
        if (fallback === undefined) {
            fallback = true;
        }
        let string = this._tr(key, this.localeOrDefault()) || this._tr(key, this.getCulture());
        if (!string && fallback) {
            string = this._tr(key, this._fallbackCulture);
            if (!string) {
                console.warn(`Translation was not found for key: ${key}.`);
                string = key;
            }
        }
        return string;
    }
    _tr(key, c) {
        let result = null;
        const culture = this._cultures[c];
        if (culture) {
            let strings = culture.strings;
            const keyTokens = key.split(".");
            for (let i = 0; i < keyTokens.length; i++) {
                const code = keyTokens[i];
                if (typeof strings[code] === "object") {
                    strings = strings[code];
                }
                if (typeof strings[code] === "string") {
                    result = strings[code];
                    break;
                }
            }
        }
        return result;
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-confirmation/payon-payment-confirmation.ts

class PayonPaymentConfirmation {
    constructor(form, paymentProviderMode) {
        this._form = form;
        this._paymentProviderMode = paymentProviderMode;
    }
    initialize() {
        const authorizationToken = Utils.getParameterByName("authorizationToken");
        if (!authorizationToken) {
            throw "Authorization token is not provided.";
        }
        let payonUrl;
        switch (this._paymentProviderMode) {
            case "live":
                payonUrl = `https://eu-prod.oppwa.com/v1/checkouts/${authorizationToken}/payment`;
                break;
            case "test":
                payonUrl = `https://eu-test.oppwa.com/v1/checkouts/${authorizationToken}/payment`;
                break;
            default:
                throw "Invalid parameter value: paymentProviderMode.";
        }
        this._form.method = "POST";
        this._form.action = payonUrl;
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-confirmation/paypal-payment-confirmation.ts
class PayPalPaymentConfirmation {
    constructor(form, sessionIdentifier) {
        this._flowIdentifier = "VOLKSWAGEN_9L76K46P4AH2W_PYMNT";
        this._form = form;
        this._sessionIdentifier = sessionIdentifier;
    }
    initialize() {
        const fraudNetScript = document.createElement("script");
        fraudNetScript.type = "application/json";
        fraudNetScript.fncls = "fnparams-dede7cc5-15fd-4c75-a9f4-36c430ee3a99";
        fraudNetScript.text = JSON.stringify({
            f: this._sessionIdentifier,
            s: this._flowIdentifier
        });
        this._form.appendChild(fraudNetScript);
        const fraudNetLoadScript = document.createElement("script");
        fraudNetLoadScript.type = "text/javascript";
        fraudNetLoadScript.text =
            'var scriptBaseURL = \'https://www.paypalobjects.com/webstatic/r/fb/\'; \
                    var dom, doc, where, iframe = document.createElement(\'iframe\'); \
                    iframe.src = "about:blank"; \
                    iframe.title = ""; \
                    iframe.role = "presentation"; \
                    (iframe.frameElement || iframe).style.cssText = "width:0;height:0; border:0"; \
                    where = document.getElementsByTagName(\'script\'); \
                    where = where[where.length - 1]; \
                    where.parentNode.insertBefore(iframe, where); \
                    try { \
                        doc = iframe.contentWindow.document; \
                    } catch (e) { \
                        dom = document.domain; \
                        iframe.src = "javascript:var d=document.open();d.domain=\'" + dom + "\';void(0);"; \
                        doc = iframe.contentWindow.document; \
                    } \
                    doc.open()._l = function () { \
                        var js = this.createElement("script"); \
                        if (dom) { \
                            this.domain = dom; \
                        } \
                        js.id = "js-iframe-async"; \
                        js.src = scriptBaseURL + \'fb-all-prod.pp.min.js\'; \
                        this.body.appendChild(js); \
                    }; \
                    doc.write(\'<body onload="document._l();">\');\
                    doc.close();';
        this._form.appendChild(fraudNetLoadScript);
        const img = document.createElement("img");
        img.src = `https://c.paypal.com/v1/r/d/b/ns?f=${this._sessionIdentifier}&s=${this._flowIdentifier}&js=0&r=1`;
        const noscript = document.createElement("noscript");
        noscript.appendChild(img);
        this._form.appendChild(noscript);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-confirmation/payment-confirmation.ts


class PaymentConfirmation {
    constructor(form, options) {
        if (!form.tagName || form.tagName.toUpperCase() !== "FORM") {
            throw "Target is invalid. A form element is expected.";
        }
        if (!options || (!options.paymentProviderMode && !options.sessionIdentifier)) {
            throw "Provided options is not a valid configuration object.";
        }
        this._form = form;
        this._options = options;
    }
    initialize() {
        if (this._options.sessionIdentifier) {
            const paypalPaymentConfirmation = new PayPalPaymentConfirmation(this._form, this._options.sessionIdentifier);
            paypalPaymentConfirmation.initialize();
        }
        else {
            const payonPaymentConfirmation = new PayonPaymentConfirmation(this._form, this._options.paymentProviderMode);
            payonPaymentConfirmation.initialize();
        }
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/kontocloud-web-api-payment-form-base.ts
class KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, configuration) {
        this._paymentData = {};
        this._onIFrameMessage = (messageEvent) => {
            const cwData = messageEvent.data && messageEvent.data.cw;
            if (!cwData || !cwData.messageReason) {
                return;
            }
            switch (cwData.messageReason) {
                case "changed":
                    this._mapPaymentData(cwData.messageData);
                    break;
                case "ready":
                    if (typeof this._options.onFormLoaded == "function") {
                        this._options.onFormLoaded();
                    }
                    break;
                case "submit":
                    this._mapPaymentData(cwData.messageData);
                    if (typeof this._options.onBeforeSubmit == "function") {
                        this._options.onBeforeSubmit(this._paymentData, () => this._submit(), () => this._cancelSubmit());
                    }
                    else {
                        this._submit();
                    }
                    break;
                case "error":
                    if (typeof this._options.onError == "function") {
                        // Backward compatibility: the data format remains the same as it was in WebSDK < 6.8.0
                        const onErrorDataObject = {
                            reason: cwData.messageReason,
                            value: cwData.messageData.value
                        };
                        this._options.onError(cwData.messageData.value, onErrorDataObject);
                    }
                    else {
                        throw new Error(JSON.stringify(cwData.messageData.value));
                    }
                    break;
            }
        };
        if (!options.authorizationToken) {
            throw new Error("The 'authorizationToken' option is required.");
        }
        if (!Array.isArray(options.iframeCssUrls)) {
            throw new Error("The 'iframeCssUrls' option must be an array.");
        }
        this._target = target;
        this._options = options;
        this._globalOptions = globalOptions;
        this._l10n = l10n;
        this._configuration = configuration;
        window.addEventListener("message", this._onIFrameMessage);
        this._iframe = this._constructWebApiFormIFrame();
        const formElement = this._constructWebApiRequestForm();
        formElement.submit();
    }
    _constructWebApiRequestForm() {
        const formElement = document.createElement("form");
        formElement.method = "post";
        formElement.action = this._globalOptions.getApiURL() + this._configuration.route;
        formElement.target = "paymentForm";
        formElement.setAttribute("data-ajax", "true");
        this._target.appendChild(formElement);
        const versionInputElement = document.createElement("input");
        versionInputElement.type = "hidden";
        versionInputElement.name = "compatibleVersion";
        versionInputElement.value = this._configuration.version;
        formElement.appendChild(versionInputElement);
        const originInputElement = document.createElement("input");
        originInputElement.type = "hidden";
        originInputElement.name = "webSDKOrigin";
        originInputElement.value = window.location.origin;
        formElement.appendChild(originInputElement);
        for (const inputName of this._configuration.dataFieldNames) {
            let inputValue = undefined;
            switch (inputName) {
                case "locale":
                    inputValue = this._l10n.locale();
                    break;
                default:
                    if (this._options[inputName] === undefined || this._options[inputName] === null) {
                        break;
                    }
                    if (Array.isArray(this._options[inputName]) || typeof this._options[inputName] === "object") {
                        inputValue = JSON.stringify(this._options[inputName]);
                    }
                    else {
                        inputValue = this._options[inputName];
                    }
                    break;
            }
            if (inputName == null || inputValue === undefined || inputValue === null) {
                continue;
            }
            const inputElement = document.createElement("input");
            inputElement.type = "hidden";
            inputElement.name = inputName;
            inputElement.value = inputValue;
            formElement.appendChild(inputElement);
        }
        return formElement;
    }
    _constructWebApiFormIFrame() {
        const iframe = document.createElement("iframe");
        iframe.name = "paymentForm";
        iframe.style.border = "none";
        iframe.style.width = "100%";
        iframe.style.maxWidth = "100%";
        iframe.sandbox.add("allow-forms");
        iframe.sandbox.add("allow-scripts");
        iframe.sandbox.add("allow-top-navigation");
        // The flag logically is not required for form loading but browsers can hide information about referrer
        // according to cross-origin policy without it. The information can be required by payment provider forms
        // (e.g. Google Chrome hides document.referrer which is required by PCI Proxy payment form)
        iframe.sandbox.add("allow-same-origin");
        this._target.appendChild(iframe);
        return iframe;
    }
    _submit() {
        this._iframe.contentWindow.postMessage({
            cw: {
                messageReason: "submit"
            }
        }, this._getApiOrigin());
    }
    _cancelSubmit() {
        this._iframe.contentWindow.postMessage({
            cw: {
                messageReason: "cancelSubmit"
            }
        }, this._getApiOrigin());
    }
    _mapPaymentData(formData) {
        if (!formData || !formData.input) {
            return;
        }
        if (this._configuration.paymentGroup === "CARDS") {
            this._mapCardsPaymentData(formData);
        }
        else if (this._configuration.paymentGroup === "BANKS") {
            this._mapBanksPaymentData(formData);
        }
        else {
            return;
        }
        if (typeof this._options.paymentInfoCallback == "function") {
            this._options.paymentInfoCallback(this._paymentData);
        }
    }
    _mapCardsPaymentData(formData) {
        switch (formData.input) {
            case "brand":
                this._paymentData.paymentBrand = formData.value;
                break;
            case "card_expiry_date":
                this._paymentData.expiryDate = formData.value;
                break;
            case "merchant_defined_data1":
                this._paymentData.cardHolder = formData.value;
                break;
        }
    }
    _mapBanksPaymentData(formData) {
        switch (formData.input) {
            case "iban":
                this._paymentData.iban = formData.value;
                break;
            case "account_holder":
                this._paymentData.accountHolder = formData.value;
                break;
            case "bank_name":
                this._paymentData.bankName = formData.value;
                break;
        }
    }
    _getApiOrigin() {
        const baseApiUrl = this._globalOptions.getApiURL();
        if (typeof window.URL === "function") {
            return new URL(baseApiUrl).origin;
        }
        const urlParts = baseApiUrl.split("://");
        if (urlParts.length > 1) {
            return urlParts[0] + "://" + urlParts[1].split("/")[0];
        }
        else {
            return urlParts[0].split("/")[0];
        }
    }
    dispose() {
        window.removeEventListener("message", this._onIFrameMessage);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/cyber-source-payment-form.ts

class CyberSourcePaymentForm extends KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, version) {
        if (!options.paymentProviderMode) {
            throw new Error("The 'paymentProviderMode' option is required.");
        }
        const configuration = {
            version: version,
            paymentGroup: "CARDS",
            route: "cybersource/paymentform",
            dataFieldNames: [
                "authorizationToken",
                "locale",
                "paymentOptionCodes",
                "paymentProviderMode",
                "isStorable",
                "isStorableCaption",
                "submitButtonTitle",
                "showLabels",
                "showPlaceholders",
                "iframeCss",
                "iframeCssUrls"
            ]
        };
        super(target, options, globalOptions, l10n, configuration);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/cyber-source-tokenex-payment-form.ts

class CyberSourceWithTokenExPaymentForm extends KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, version) {
        if (!options.paymentProviderMode) {
            throw new Error("The 'paymentProviderMode' option is required.");
        }
        try {
            if (JSON.parse(atob(options.authorizationToken)).storeOptionMode) {
                options.isStorable = false;
            }
        }
        catch (e) {
            throw new Error("The 'authorizationToken' option is not a Base64 encoded string or not valid JSON object.");
        }
        const configuration = {
            version: version,
            paymentGroup: "CARDS",
            route: "cybersourcetokenex/paymentform",
            dataFieldNames: [
                "authorizationToken",
                "locale",
                "paymentOptionCodes",
                "paymentProviderMode",
                "isStorable",
                "isStorableCaption",
                "submitButtonTitle",
                "showLabels",
                "showPlaceholders",
                "iframeCss",
                "iframeCssUrls"
            ]
        };
        super(target, options, globalOptions, l10n, configuration);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/payments-os-payment-form.ts
class PaymentsOsPaymentForm {
    constructor(options, l10n) {
        const authorizationTokenParts = options.authorizationToken.split("#");
        const urlParts = authorizationTokenParts[0].split("?");
        let location;
        if (urlParts
            .slice(1)
            .join("?")
            .search(/(\&|^)lang\=\w+(\-\w+)?(\&|$)/) === -1 &&
            l10n.locale()) {
            const locale = `lang=${l10n.getCulture()}`;
            if (urlParts.length > 1) {
                urlParts[urlParts.length - 1] += `&${locale}`;
            }
            else {
                urlParts.push(locale);
            }
            authorizationTokenParts[0] = urlParts.join("?");
            location = authorizationTokenParts.join("#");
        }
        else {
            location = options.authorizationToken;
        }
        if (!this._isUrl(location)) {
            throw new Error("Provided 'authorizationToken' is not a valid URI.");
        }
        window.location.href = location;
    }
    dispose() {
        //
    }
    _isUrl(value) {
        // https://gist.github.com/dperini/729294
        const regex = "^(?:(?:http|https)://)(?:\\S+(?::\\S*)?@)?(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))?)(?::\\d{2,5})?(?:[/?#]\\S*)?$";
        const pattern = new RegExp(regex, "i");
        return typeof value === "string" && pattern.exec(value);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/payon-payment-form.ts

class PayonPaymentForm {
    constructor(target, options, l10n) {
        this._supportedIbanCountries = ["AT", "BE", "CH", "CY", "DE", "EE", "ES", "FI", "FR", "GR", "IE", "IT", "LT", "LU", "LV", "MC", "MT", "NL", "PT", "SI", "SK", "SM"];
        this._paymentOptionCodeToBrandsMap = {
            MSTRCRD: { value: "MASTER", group: "card" },
            VISA: { value: "VISA", group: "card" },
            VISADBIT: { value: "VISADEBIT", group: "card" },
            MSTRO: { value: "MAESTRO", group: "card" },
            AMEX: { value: "AMEX", group: "card" },
            CRTBANCAIR: { value: "CARTEBANCAIRE", group: "card" },
            JCB: { value: "JCB", group: "card" },
            PAYPAL: { value: "PAYPAL", group: "other" },
            GIROPAY: { value: "GIROPAY", group: "other" },
            IDEAL: { value: "IDEAL", group: "other" },
            BNKACCT: { value: "DIRECTDEBIT_SEPA", group: "other" }
        };
        this._wpwlErrorToCwMap = {
            "wpwl-has-error": "cw-has-error",
            "wpwl-hint": "cw-hint",
            "wpwl-hint-accountHolderError": "cw-hint-accountHolder",
            "wpwl-hint-accountIbanError": "cw-hint-iban",
            "wpwl-hint-cardHolderError": "cw-hint-cardHolderError",
            "wpwl-hint-cardNumberError": "cw-hint-cardNumber",
            "wpwl-hint-cvvError": "cw-hint-cvv",
            "wpwl-hint-expiryMonthError": "cw-hint-expiryError"
        };
        this._wpwlToCwMap = {
            "wpwl-brand": "cw-brand",
            "wpwl-brand-BRAND": "cw-brand-BRAND",
            "wpwl-brand-card": "cw-brand-card",
            "wpwl-button": "cw-button",
            "wpwl-button-pay": "cw-button-pay",
            "wpwl-clearfix": "cw-clearfix",
            "wpwl-container": "cw-container",
            "wpwl-container-card": "cw-container-card",
            "wpwl-container-directDebit": "cw-container-bankAccount",
            "wpwl-control": "cw-control",
            "wpwl-control-accountHolder": "cw-control-accountHolder",
            "wpwl-control-accountIban": "cw-control-iban",
            "wpwl-control-brand": "cw-control-brand",
            "wpwl-control-cardHolder": "cw-control-cardHolder",
            "wpwl-control-cardNumber": "cw-control-cardNumber",
            "wpwl-control-cvv": "cw-control-cvv",
            "wpwl-control-expiry": "cw-control-expiry",
            "wpwl-control-iframe": "cw-control-iframe",
            "wpwl-form": "cw-form",
            "wpwl-form-card": "cw-form-card",
            "wpwl-form-directDebit": "cw-form-bankAccount",
            "wpwl-group": "cw-group",
            "wpwl-group-accountHolder": "cw-group-accountHolder",
            "wpwl-group-accountIban": "cw-group-iban",
            "wpwl-group-brand": "cw-group-brand",
            "wpwl-group-cardHolder": "cw-group-cardHolder",
            "wpwl-group-cardNumber": "cw-group-cardNumber",
            "wpwl-group-cvv": "cw-group-cvv",
            "wpwl-group-expiry": "cw-group-expiry",
            "wpwl-group-submit": "cw-group-submit",
            "wpwl-label": "cw-label",
            "wpwl-label-accountHolder": "cw-label-accountHolder",
            "wpwl-label-accountIban": "cw-label-iban",
            "wpwl-label-brand": "cw-label-brand",
            "wpwl-label-cardHolder": "cw-label-cardHolder",
            "wpwl-label-cardNumber": "cw-label-cardNumber",
            "wpwl-label-cvv": "cw-label-cvv",
            "wpwl-label-expiry": "cw-label-expiry",
            "wpwl-wrapper": "cw-wrapper",
            "wpwl-wrapper-accountHolder": "cw-wrapper-accountHolder",
            "wpwl-wrapper-accountIban": "cw-wrapper-iban",
            "wpwl-wrapper-brand": "cw-wrapper-brand",
            "wpwl-wrapper-cardHolder": "cw-wrapper-cardHolder",
            "wpwl-wrapper-cardNumber": "cw-wrapper-cardNumber",
            "wpwl-wrapper-cvv": "cw-wrapper-cvv",
            "wpwl-wrapper-expiry": "cw-wrapper-expiry",
            "wpwl-wrapper-submit": "cw-wrapper-submit"
        };
        this._submitPrevented = false;
        if (!options.paymentProviderMode) {
            throw new Error("The 'paymentProviderMode' option is required.");
        }
        if (options.paymentProviderMode !== "live" && options.paymentProviderMode !== "test") {
            throw "Invalid parameter value: paymentProviderMode.";
        }
        if (!Utils.isUrl(options.callbackUrl)) {
            throw new Error("The Callback URL must be valid");
        }
        if (options.confirmationUrl && !Utils.isUrl(options.confirmationUrl)) {
            throw new Error("The Confirmation URL must be valid");
        }
        this._paymentBrands = options.paymentOptionCodes.map(paymentOptionCode => this._paymentOptionCodeToBrandsMap[paymentOptionCode]);
        if (this._paymentBrands.some(paymentBrand => paymentBrand.group === "other")) {
            if (this._paymentBrands.some(paymentBrand => paymentBrand.group === "card")) {
                throw ("Payment option codes collection cannot contain codes from different payment groups. " +
                    "There should be either only codes from payment group 'Cards' or a single code from payment group 'Other'.");
            }
            if (this._paymentBrands.length > 1) {
                throw "Payment option codes collection cannot contain multiple codes from payment group 'Other'.";
            }
        }
        this._target = target;
        this._options = options;
        this._l10n = l10n;
        this._appendForm();
        this._appendCustomCss();
        window["wpwlOptions"] = this._constructWpwlOptions();
        this._load();
    }
    dispose() {
        window["wpwl"].unload();
    }
    _appendForm() {
        const cwContainer = document.createElement("div");
        cwContainer.classList.add("cw");
        this._appendCssClasses(cwContainer, ["cw"]);
        const cwHtml = document.createElement("div");
        cwHtml.classList.add("cw-html");
        this._appendCssClasses(cwHtml, ["cw-html"]);
        const cwBody = document.createElement("div");
        cwBody.classList.add("cw-body");
        this._appendCssClasses(cwBody, ["cw-body"]);
        const formElement = document.createElement("form");
        formElement.action = this._options.callbackUrl;
        formElement.className = "paymentWidgets";
        formElement.setAttribute("data-brands", this._paymentBrands.map(paymentBrand => paymentBrand.value).join(" "));
        this._target.appendChild(formElement);
        cwBody.appendChild(formElement);
        cwHtml.appendChild(cwBody);
        cwContainer.appendChild(cwHtml);
        this._target.appendChild(cwContainer);
    }
    _appendCustomCss() {
        let customCss = "";
        if (!this._options.showPlaceholders) {
            customCss += ".wpwl-control::-webkit-input-placeholder {  opacity: 0; }\n";
            customCss += ".wpwl-control::-moz-placeholder {  opacity: 0; }\n";
            customCss += ".wpwl-control:-ms-input-placeholder {  opacity: 0; }\n";
        }
        const style = document.createElement("style");
        style.type = "text/css";
        style.appendChild(document.createTextNode(customCss));
        document.head.appendChild(style);
    }
    _constructWpwlOptions() {
        var _a, _b;
        const wpwlOptions = {
            style: "plain",
            locale: this._resolveCulture(),
            useSummaryPage: !!this._options.confirmationUrl,
            brandDetection: this._paymentBrands.length > 1,
            showCVVHint: this._options.showCVVHint,
            showLabels: this._options.showLabels,
            labels: this._constructTranslations({
                accountHolder: { key: "aspo_newcard_txt_acc_holder" },
                accountIban: { key: "aspo_newcard_txt_iban" },
                cardHolder: { key: "aspo_newcard_txt_card_holder" },
                cardHolderError: { key: "validation_msg_card_holder" },
                cardNumber: { key: "aspo_newcard_txt_card_number" },
                cvv: { key: "aspo_newcard_txt_cvv" },
                cvvPlaceholder: { key: "aspo_newcard_txt_cvv_holder" },
                expiryDate: { key: "aspo_newcard_txt_expiry_date" },
                mmyy: { key: "aspo_newcard_txt_expiry_date_holder" }
            }),
            errorMessages: this._constructTranslations({
                cvvError: { key: "validation_msg_card_cvv" },
                accountHolderError: { key: "validation_msg_invalid", formatKeys: ["aspo_newcard_txt_acc_holder"] },
                accountIbanError: { key: "validation_msg_invalid", formatKeys: ["aspo_newcard_txt_iban"] }
            }),
            registrations: {
                requireCvv: this._options.requireCvv || false,
                hideInitialPaymentForms: true
            },
            onChangeBrand: (brand) => this._onChangeBrand(brand),
            onSaveTransactionData: () => this._onSaveTransactionData(),
            onFocusIframeCommunication: function () {
                Utils.fireEvent(this.$iframe.get(0), "iframefocusin");
            },
            onBlurIframeCommunication: function () {
                Utils.fireEvent(this.$iframe.get(0), "iframeblur");
            },
            onReady: () => this._onReady(),
            onError: (error) => this._onError(error),
            onBeforeSubmitCard: (event) => this._onBeforeSubmitCard(event),
            onBeforeSubmitDirectDebit: (event) => this._onBeforeSubmitDirectDebit(event),
            onBeforeSubmitOnlineTransfer: () => this._onPaymentInfoCallback(),
            onBeforeSubmitVirtualAccount: () => this._onPaymentInfoCallback(),
            onBlurCardNumber: (isValid) => this._handlingCwErrorClasses(isValid, document.querySelector(".wpwl-control-cardNumber")),
            onBlurSecurityCode: (isValid) => this._handlingCwErrorClasses(isValid, document.querySelector(".wpwl-control-cvv"))
        };
        const iframePlaceholderStyles = {};
        if (!this._options.showPlaceholders) {
            iframePlaceholderStyles.opacity = "0";
        }
        else {
            iframePlaceholderStyles.color = this._options.placeholdersColor;
        }
        wpwlOptions.iframeStyles = {
            ...{
                "card-number-placeholder": {
                    ...(_a = this._options.iframeStyles) === null || _a === void 0 ? void 0 : _a["card-number-placeholder"],
                    ...iframePlaceholderStyles
                },
                "cvv-placeholder": {
                    ...(_b = this._options.iframeStyles) === null || _b === void 0 ? void 0 : _b["cvv-placeholder"],
                    ...iframePlaceholderStyles
                }
            }
        };
        const targetName = typeof this._options.targetName !== "undefined" ? this._options.targetName : window !== window.top ? window.name : null;
        if (targetName) {
            wpwlOptions.paymentTarget = targetName;
            wpwlOptions.shopperResultTarget = targetName;
        }
        document.addEventListener("iframefocusin", (event) => {
            this._removeValidationError(event.target);
        });
        return wpwlOptions;
    }
    _resolveCulture() {
        const culture = this._l10n.getCulture();
        switch (culture) {
            case "zh":
                return "cn";
            case "cs":
                return "cz";
            case "el":
                return "gr";
            default:
                return culture;
        }
    }
    _constructTranslations(translationKeys) {
        const translations = {};
        for (let translationKey in translationKeys) {
            if (!translationKeys.hasOwnProperty(translationKey)) {
                continue;
            }
            const translationResource = translationKeys[translationKey];
            let translation = this._l10n.translate(translationResource.key, false);
            if (!translation) {
                continue;
            }
            const formatKeys = translationResource.formatKeys;
            if (formatKeys) {
                const formatValues = [];
                for (const key of formatKeys) {
                    formatValues.push(this._l10n.translate(key, false));
                }
                translation = Utils.format(translation, formatValues);
            }
            translations[translationKey] = translation;
        }
        return translations;
    }
    _onChangeBrand(brand) {
        if (this._paymentBrands.length <= 1) {
            return;
        }
        const brandLogo = document.querySelector("form.wpwl-form-card .wpwl-brand-card");
        const brandLabel = document.querySelector("form.wpwl-form-card .wpwl-label-brand");
        if (typeof this._latestBrand === "undefined") {
            // Hide brand on initial loading
            brandLogo.style.display = "none";
            if (this._options.showLabels) {
                brandLabel.style.visibility = "hidden";
            }
            this._latestBrand = null;
        }
        else if (brand !== this._latestBrand) {
            brandLogo.style.display = null;
            if (this._options.showLabels) {
                brandLabel.style.visibility = null;
            }
            this._latestBrand = brand;
        }
    }
    _onSaveTransactionData() {
        location.href = Utils.url(this._options.confirmationUrl, { authorizationToken: this._options.authorizationToken });
    }
    _onReady() {
        const brandWrapper = document.querySelector("form.wpwl-form-card .wpwl-wrapper-brand");
        if (brandWrapper) {
            brandWrapper.style.display = "none";
        }
        const formRegistrationsWrapper = document.querySelector("div.wpwl-form-registrations");
        if (formRegistrationsWrapper) {
            formRegistrationsWrapper.parentNode.removeChild(formRegistrationsWrapper);
        }
        if (this._options.isStorable) {
            const createRegistrationContainer = this._buildCreateRegistrationContainer();
            this._insertElementBeforeGroup(createRegistrationContainer);
        }
        const submit = document.querySelector(".wpwl-button");
        submit.className += " ignore-disable-on-submit";
        if (this._paymentBrands[0].value !== "PAYPAL") {
            submit.textContent = this._options.submitButtonTitle;
        }
        this._submitButton = submit;
        this._initFormValidation();
        this._appendCwClasses(this._wpwlToCwMap);
        if (typeof this._options.onFormLoaded === "function") {
            this._options.onFormLoaded();
        }
    }
    _insertElementBeforeGroup(element) {
        const cardGroup = document.querySelector("form.wpwl-form-card .wpwl-group-submit");
        const directDebitGroup = document.querySelector("form.wpwl-form-directDebit .wpwl-group-submit");
        if (cardGroup) {
            cardGroup.parentNode.insertBefore(element, cardGroup);
        }
        if (directDebitGroup) {
            directDebitGroup.parentNode.insertBefore(element, directDebitGroup);
        }
    }
    _initFormValidation() {
        const form = document.querySelector(".wpwl-form");
        form.addEventListener("submit", () => setTimeout(() => this._appendCwClasses(this._wpwlErrorToCwMap), 30));
        const expireDateElement = document.querySelector(".wpwl-control-expiry");
        if (expireDateElement) {
            expireDateElement.addEventListener("focus", () => this._removeValidationError(expireDateElement));
            expireDateElement.addEventListener("blur", () => {
                this._handlingCwErrorClasses(!expireDateElement.classList.contains("wpwl-has-error"), expireDateElement);
            });
        }
        const cardHolderElement = document.querySelector(".wpwl-control-cardHolder");
        if (cardHolderElement) {
            const message = this._l10n.translate("validation_msg_card_holder");
            const hintClassName = "wpwl-hint-cardHolderError";
            const validate = () => !cardHolderElement.classList.contains("wpwl-has-error");
            cardHolderElement.addEventListener("focus", () => this._removeValidationError(cardHolderElement));
            this._addBlurEventListener(cardHolderElement, message, hintClassName, validate);
            this._addSubmitEventListener(cardHolderElement, form, message, hintClassName);
        }
        const accountHolderElement = document.querySelector(".wpwl-control-accountHolder");
        if (accountHolderElement) {
            const message = this._l10n.translate("payment_form_invalid_account_holder");
            const hintClassName = "wpwl-hint-accountHolderError";
            const validate = () => !accountHolderElement.classList.contains("wpwl-has-error");
            accountHolderElement.addEventListener("focus", () => this._removeValidationError(accountHolderElement));
            this._addBlurEventListener(accountHolderElement, message, hintClassName, validate);
            this._addSubmitEventListener(accountHolderElement, form, message, hintClassName);
        }
        const ibanElement = document.querySelector(".wpwl-control-accountIban");
        if (ibanElement) {
            const message = this._l10n.translate("payment_form_invalid_iban_country");
            const hintClassName = "wpwl-hint-accountIbanError";
            const validate = () => {
                if (ibanElement.classList.contains("wpwl-has-error") || !ibanElement.value) {
                    return false;
                }
                const ibanCountry = ibanElement.value.substring(0, 2).toUpperCase();
                return this._supportedIbanCountries.indexOf(ibanCountry) === -1;
            };
            ibanElement.addEventListener("focus", () => this._removeValidationError(ibanElement));
            this._addBlurEventListener(ibanElement, message, hintClassName, validate);
        }
    }
    _addBlurEventListener(element, errorMessage, hintClassName, validate) {
        element.addEventListener("blur", () => {
            if (!validate()) {
                this._handlingCwErrorClasses(false, element);
                return;
            }
            if (!element.value || !!Utils.validateStringForRestrictedSymbols(element.value)) {
                this._handlingCwErrorClasses(true, element);
                return;
            }
            this._appendValidationError(element, hintClassName, errorMessage);
        });
    }
    _addSubmitEventListener(element, form, errorMessage, hintClassName) {
        form.addEventListener("submit", () => {
            if (element.value) {
                return;
            }
            this._appendValidationError(element, hintClassName, errorMessage);
        });
    }
    _buildCreateRegistrationContainer() {
        const createRegistrationContainer = document.createElement("div");
        createRegistrationContainer.className = "cw-group wpwl-group cw-group-storeOption wpwl-group-createRegistration cw-clearfix wpwl-clearfix";
        const createRegistrationLabel = document.createElement("div");
        createRegistrationLabel.className = "cw-label wpwl-label cw-label-storeOption wpwl-label-createRegistration";
        const createRegistrationWrapper = document.createElement("div");
        createRegistrationWrapper.className = "cw-wrapper wpwl-wrapper cw-wrapper-storeOption wpwl-wrapper-createRegistration";
        const createRegistrationCheckboxWrapper = document.createElement("div");
        createRegistrationCheckboxWrapper.className = "checkbox";
        const createRegistrationCheckboxLabelWrapper = document.createElement("label");
        const createRegistrationCheckbox = document.createElement("input");
        createRegistrationCheckbox.type = "checkbox";
        createRegistrationCheckbox.name = "createRegistration";
        createRegistrationCheckbox.value = "true";
        createRegistrationCheckbox.classList.add("cw-control", "cw-control-storeOption");
        createRegistrationCheckbox.checked = true;
        const isStorableSpan = document.createElement("span");
        isStorableSpan.textContent = this._options.isStorableCaption
            ? this._options.isStorableCaption
            : this._l10n.translate("payment_form_store_payment_method");
        isStorableSpan.classList.add("cw-text", "cw-text-storeOption");
        createRegistrationCheckboxLabelWrapper.append(createRegistrationCheckbox);
        createRegistrationCheckboxLabelWrapper.append(isStorableSpan);
        createRegistrationCheckboxWrapper.append(createRegistrationCheckboxLabelWrapper);
        createRegistrationWrapper.append(createRegistrationCheckboxWrapper);
        createRegistrationContainer.append(createRegistrationLabel);
        createRegistrationContainer.append(createRegistrationWrapper);
        return createRegistrationContainer;
    }
    _appendCwClasses(dictionary) {
        for (const [wpwlClassName, cwClassName] of Object.entries(dictionary !== null && dictionary !== void 0 ? dictionary : this._wpwlToCwMap)) {
            for (const element of document.querySelectorAll(`.${wpwlClassName}`)) {
                element.classList.add(cwClassName);
                this._appendCssClasses(element, [cwClassName]);
            }
        }
    }
    _appendCssClasses(element, cwClassNames) {
        if (!this._options.iframeCssClasses || Object.entries(this._options.iframeCssClasses).length === 0) {
            return;
        }
        for (const className of cwClassNames) {
            const additionalClasses = this._options.iframeCssClasses[className];
            if (additionalClasses) {
                element.classList.add(...additionalClasses.replace(/\s\s+/g, " ").trim().split(" "));
            }
        }
    }
    _removeValidationError(element) {
        for (const [_, cwClassName] of Object.entries(this._wpwlErrorToCwMap)) {
            element.classList.remove(cwClassName);
            if (!this._options.iframeCssClasses || Object.entries(this._options.iframeCssClasses).length === 0) {
                return;
            }
            const additionalClasses = this._options.iframeCssClasses[cwClassName];
            if (additionalClasses) {
                element.classList.remove(...additionalClasses.replace(/\s\s+/g, " ").trim().split(" "));
            }
        }
    }
    _appendValidationError(element, hintClass, errorMessage) {
        const cwHasError = "cw-has-error";
        const cwHint = "cw-hint";
        const cwButtonError = "cw-button-error";
        element.classList.add(cwHasError, "wpwl-has-error");
        const validationMessageElement = document.createElement("div");
        validationMessageElement.classList.add(cwHint, "wpwl-hint");
        let cwHintClass = hintClass.replace("wpwl", "cw");
        if (cwHintClass.includes("accountIbanError")) {
            cwHintClass = cwHintClass.replace("accountIbanError", "iban");
        }
        else if (cwHintClass.includes("accountHolderError")) {
            cwHintClass = cwHintClass.replace("accountHolderError", "accountHolder");
        }
        validationMessageElement.classList.add(cwHintClass, hintClass);
        validationMessageElement.appendChild(document.createTextNode(errorMessage));
        element.parentNode.insertBefore(validationMessageElement, element.nextSibling);
        this._submitButton.classList.add(cwButtonError, "wpwl-button-error");
        this._submitButton.disabled = true;
        this._appendCssClasses(element, [cwHasError]);
        this._appendCssClasses(validationMessageElement, [cwHint, cwHintClass]);
        this._appendCssClasses(this._submitButton, [cwButtonError]);
    }
    _handlingCwErrorClasses(isValid, element) {
        setTimeout(() => {
            if (!isValid) {
                this._appendCwClasses(this._wpwlErrorToCwMap);
            }
            else {
                this._removeValidationError(element);
            }
        }, 30);
    }
    _onError(error) {
        if (typeof this._options.onError === "function") {
            this._options.onError(error.message, error);
        }
    }
    _onBeforeSubmitCard(event) {
        const cardHolderElement = document.querySelector(".wpwl-control-cardHolder");
        if (!cardHolderElement.value || !Utils.validateStringForRestrictedSymbols(cardHolderElement.value)) {
            const message = this._l10n.translate("validation_msg_card_holder");
            this._appendValidationError(cardHolderElement, "wpwl-hint-cardHolderError", message);
            return false;
        }
        const paymentInfo = PayonPaymentForm._constructPaymentInfo({
            paymentBrand: ".wpwl-control-brand",
            expiryDate: ".wpwl-control-expiry",
            cardHolder: ".wpwl-control-cardHolder"
        });
        if (typeof this._options.paymentInfoCallback == "function") {
            this._options.paymentInfoCallback(paymentInfo);
        }
        return !this._tryPreventSubmit(event, paymentInfo);
    }
    _onBeforeSubmitDirectDebit(event) {
        const accountHolderElement = document.querySelector(".wpwl-control-accountHolder");
        if (!accountHolderElement.value || !Utils.validateStringForRestrictedSymbols(accountHolderElement.value)) {
            const message = this._l10n.translate("payment_form_invalid_account_holder");
            this._appendValidationError(accountHolderElement, "wpwl-hint-accountHolderError", message);
            return false;
        }
        const ibanElement = document.querySelector(".wpwl-control-accountIban");
        const ibanCountry = ibanElement.value.substring(0, 2).toUpperCase();
        if (this._supportedIbanCountries.indexOf(ibanCountry) === -1) {
            const message = this._l10n.translate("payment_form_invalid_iban_country");
            this._appendValidationError(ibanElement, "wpwl-hint-accountIbanError", message);
            return false;
        }
        const paymentInfo = PayonPaymentForm._constructPaymentInfo({
            accountHolder: ".wpwl-control-accountHolder",
            iban: ".wpwl-control-accountIban"
        });
        if (typeof this._options.paymentInfoCallback == "function") {
            this._options.paymentInfoCallback(paymentInfo);
        }
        return !this._tryPreventSubmit(event, paymentInfo);
    }
    _onPaymentInfoCallback() {
        const paymentInfo = PayonPaymentForm._constructPaymentInfo();
        if (typeof this._options.paymentInfoCallback == "function") {
            this._options.paymentInfoCallback(paymentInfo);
        }
        return true;
    }
    _tryPreventSubmit(event, paymentInfo) {
        if (this._submitPrevented) {
            return false;
        }
        if (typeof this._options.onBeforeSubmit == "function") {
            event.preventDefault();
            this._submitButton.disabled = false;
            this._options.onBeforeSubmit(paymentInfo, () => {
                this._submitPrevented = true;
                setTimeout(() => {
                    this._submitButton.click();
                }, 1);
            });
            return true;
        }
        return false;
    }
    static _constructPaymentInfo(fields) {
        const paymentInfo = {};
        if (fields) {
            for (let key in fields) {
                const input = document.querySelector(fields[key]);
                if (input) {
                    paymentInfo[key] = input.value;
                }
            }
        }
        return paymentInfo;
    }
    _load() {
        const payonUrl = this._options.paymentProviderMode === "live" ? "https://eu-prod.oppwa.com/v1/paymentWidgets.js" : "https://eu-test.oppwa.com/v1/paymentWidgets.js";
        const scriptElement = document.createElement("script");
        scriptElement.src = Utils.url(payonUrl, { checkoutId: this._options.authorizationToken });
        scriptElement.async = true;
        document.body.appendChild(scriptElement);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/payon-pci-proxy-payment-form.ts

class PayonWithPciProxyPaymentForm extends KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, version) {
        try {
            JSON.parse(atob(options.authorizationToken));
        }
        catch (e) {
            throw new Error("The 'authorizationToken' option is not a Base64 encoded string or not valid JSON object.");
        }
        const configuration = {
            version: version,
            paymentGroup: "CARDS",
            route: "payonpciproxy/paymentform",
            dataFieldNames: ["authorizationToken", "locale", "paymentOptionCodes", "submitButtonTitle", "showLabels", "iframeCss", "iframeCssUrls", "iframeCssClasses"]
        };
        super(target, options, globalOptions, l10n, configuration);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/paypal-payment-form.ts
class PayPalPaymentForm {
    constructor(target, options, l10n) {
        if (!options.paymentProviderMode) {
            throw new Error("The 'paymentProviderMode' option is required.");
        }
        if (options.paymentProviderMode !== "live" && options.paymentProviderMode !== "test") {
            throw "Invalid parameter value: paymentProviderMode.";
        }
        if (options.paypalButtonStyle && options.paypalButtonStyle.label && options.paypalButtonStyle.label === "credit") {
            throw "Invalid parameter value: paypalButtonStyle. PayPal button label 'credit' value is not supported.";
        }
        this._target = target;
        this._options = options;
        this._l10n = l10n;
        if (this._options.trackingID && this._options.flowIdentifier) {
            this._renderFraudNewScript();
        }
        const paypalScript = document.createElement("script");
        paypalScript.type = "text/javascript";
        paypalScript.src = "https://www.paypalobjects.com/api/checkout.js";
        paypalScript.onload = () => this._onload();
        document.getElementsByTagName("head")[0].appendChild(paypalScript);
    }
    dispose() {
        //
    }
    _renderFraudNewScript() {
        const fraudNetScript = document.createElement("script");
        fraudNetScript.type = "application/json";
        fraudNetScript.fncls = "fnparams-dede7cc5-15fd-4c75-a9f4-36c430ee3a99";
        fraudNetScript.text = JSON.stringify({
            f: this._options.trackingID,
            s: this._options.flowIdentifier
        });
        document.getElementsByTagName("head")[0].appendChild(fraudNetScript);
        const fraudNetLoadScript = document.createElement("script");
        fraudNetLoadScript.type = "text/javascript";
        fraudNetLoadScript.text =
            'var scriptBaseURL = \'https://www.paypalobjects.com/webstatic/r/fb/\'; \
var dom, doc, where, iframe = document.createElement(\'iframe\'); \
iframe.src = "about:blank"; \
iframe.title = ""; \
iframe.role = "presentation"; \
(iframe.frameElement || iframe).style.cssText = "width:0;height:0; border:0"; \
where = document.getElementsByTagName(\'script\'); \
where = where[where.length - 1]; \
where.parentNode.insertBefore(iframe, where); \
try { \
    doc = iframe.contentWindow.document; \
} catch (e) { \
    dom = document.domain; \
    iframe.src = "javascript:var d=document.open();d.domain=\'" + dom + "\';void(0);"; \
    doc = iframe.contentWindow.document; \
} \
doc.open()._l = function () { \
    var js = this.createElement("script"); \
    if (dom) { \
        this.domain = dom; \
    } \
    js.id = "js-iframe-async"; \
    js.src = scriptBaseURL + \'fb-all-prod.pp.min.js\'; \
    this.body.appendChild(js); \
}; \
doc.write(\'<body onload="document._l();">\'); \
doc.close();';
        document.getElementsByTagName("head")[0].appendChild(fraudNetLoadScript);
        const img = document.createElement("img");
        img.src = `https://c.paypal.com/v1/r/d/b/ns?f=${this._options.trackingID}&s=${this._options.flowIdentifier}&js=0&r=1`;
        const noscript = document.createElement("noscript");
        noscript.appendChild(img);
        document.getElementsByTagName("head")[0].appendChild(noscript);
    }
    _onload() {
        const environment = this._options.paymentProviderMode === "live" ? window["paypal"].ENV.PRODUCTION : window["paypal"].ENV.SANDBOX;
        let locale = this._l10n.localeOrDefault().replace("-", "_");
        try {
            window["paypal"].Button.props.locale.validate(locale);
        }
        catch (e) {
            locale = "";
        }
        window["paypal"].Button.render({
            env: environment,
            commit: true,
            locale: locale,
            style: {
                size: "small",
                color: "gold",
                shape: "pill",
                label: "paypal",
                tagline: false,
                ...this._options.paypalButtonStyle
            },
            payment: () => this._onBeforeSubmitCallback(),
            onAuthorize: (data, actions) => this._onCompleteCallback(data, actions),
            onCancel: (data, actions) => this._onCompleteCallback(data, actions),
            onError: (error) => this._onErrorCallback(error),
            onRender: () => this._onRenderCallback()
        }, this._target);
    }
    _onErrorCallback(error) {
        if (typeof this._options.onError === "function") {
            this._options.onError(error.message, error);
        }
    }
    _onRenderCallback() {
        if (typeof this._options.onFormLoaded === "function") {
            this._options.onFormLoaded();
        }
    }
    _onBeforeSubmitCallback() {
        if (typeof this._options.onBeforeSubmit === "function") {
            this._options.onBeforeSubmit();
        }
        return this._options.authorizationToken;
    }
    _onCompleteCallback(data, actions) {
        const args = new CompletePayPalPaymentData(data);
        if (typeof this._options.onComplete === "function") {
            this._options.onComplete(args);
        }
        if (!args.isRedirectPrevented()) {
            actions.redirect();
        }
    }
}
class CompletePayPalPaymentData {
    constructor(data) {
        this._isRedirectPrevented = false;
        this._data = data;
    }
    preventRedirect() {
        this._isRedirectPrevented = true;
    }
    isRedirectPrevented() {
        return this._isRedirectPrevented;
    }
    getPaymentProviderData() {
        return this._data;
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/sepa-payment-form.ts

class SepaPaymentForm extends KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, version) {
        try {
            JSON.parse(atob(options.authorizationToken));
        }
        catch (e) {
            throw new Error("The 'authorizationToken' option is not a Base64 encoded string or not valid JSON object.");
        }
        const configuration = {
            version: version,
            paymentGroup: "BANKS",
            route: "sepa/paymentform",
            dataFieldNames: ["authorizationToken", "locale", "submitButtonTitle", "showLabels", "showPlaceholders", "iframeCss", "iframeCssUrls", "iframeCssClasses"]
        };
        super(target, options, globalOptions, l10n, configuration);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/vesta-tokenex-payment-form.ts

class VestaWithTokenExPaymentForm extends KontoCloudWebApiPaymentFormBase {
    constructor(target, options, globalOptions, l10n, version) {
        if (!options.paymentProviderMode) {
            throw new Error("The 'paymentProviderMode' option is required.");
        }
        try {
            if (JSON.parse(atob(options.authorizationToken)).storeOptionMode) {
                options.isStorable = false;
            }
        }
        catch (e) {
            throw new Error("The 'authorizationToken' option is not a Base64 encoded string or not valid JSON object.");
        }
        const configuration = {
            version: version,
            paymentGroup: "CARDS",
            route: "vesta/paymentform",
            dataFieldNames: [
                "authorizationToken",
                "locale",
                "paymentOptionCodes",
                "paymentProviderMode",
                "isStorable",
                "isStorableCaption",
                "submitButtonTitle",
                "showLabels",
                "showPlaceholders",
                "iframeCss",
                "iframeCssUrls"
            ]
        };
        super(target, options, globalOptions, l10n, configuration);
    }
}

;// CONCATENATED MODULE: ./src/ts/payment-form/payment-form.ts








class PaymentForm {
    constructor(target, options, globalOptions, l10n, version) {
        if (!(target instanceof HTMLElement)) {
            throw new Error("Provided target is not a valid HTMLElement.");
        }
        else if (target instanceof HTMLFormElement) {
            throw new Error("HTMLFormElement cannot be used as target.");
        }
        if (!options) {
            throw new Error("options required.");
        }
        if (!Array.isArray(options.paymentOptionCodes) || options.paymentOptionCodes.length === 0) {
            throw new Error("Payment option codes is not a valid collection.");
        }
        this._globalOptions = globalOptions;
        this._l10n = l10n;
        this._options = {
            ...{
                showLabels: true,
                showPlaceholders: true,
                placeholdersColor: "#757575",
                showCVVHint: false,
                iframeCssUrls: []
            },
            ...options
        };
        this._version = version;
        this._paymentFormWrapper = document.createElement("div");
        this._paymentFormWrapper.style.visibility = "hidden";
        this._paymentFormWrapper.style.height = "100%";
        this._paymentFormWrapper.style.width = "100%";
        this._paymentFormWrapper.style.maxWidth = "100%";
        target.appendChild(this._paymentFormWrapper);
        this._initializeOptions();
        this._render();
    }
    dispose() {
        if (!this._paymentFormDisposeCallback) {
            return;
        }
        this._paymentFormDisposeCallback();
        this._paymentFormDisposeCallback = null;
    }
    _initializeOptions() {
        if (typeof this._options.onFormLoaded === "function") {
            const originalOnFormLoaded = this._options.onFormLoaded;
            this._options.onFormLoaded = () => {
                originalOnFormLoaded();
                this._paymentFormWrapper.style.visibility = "visible";
            };
        }
        else {
            this._options.onFormLoaded = () => {
                this._paymentFormWrapper.style.visibility = "visible";
            };
        }
        this._globalOptions.validatePaymentOptionCodesSupported(this._options.paymentOptionCodes);
        if (this._options.locale) {
            this._globalOptions.update({ locale: this._options.locale });
        }
    }
    _render() {
        let paymentFormResult;
        switch (this._globalOptions.resolvePaymentProvider(this._options.paymentOptionCodes)) {
            case "CYBERSOURCE":
                paymentFormResult = new CyberSourcePaymentForm(this._paymentFormWrapper, this._options, this._globalOptions, this._l10n, this._version);
                break;
            case "CYBERSOURCEWITHTOKENEX":
                paymentFormResult = new CyberSourceWithTokenExPaymentForm(this._paymentFormWrapper, this._options, this._globalOptions, this._l10n, this._version);
                break;
            case "VESTAWITHTOKENEX":
                paymentFormResult = new VestaWithTokenExPaymentForm(this._paymentFormWrapper, this._options, this._globalOptions, this._l10n, this._version);
                break;
            case "PAYMENTSOS":
                paymentFormResult = new PaymentsOsPaymentForm(this._options, this._l10n);
                break;
            case "SEPA":
                paymentFormResult = new SepaPaymentForm(this._paymentFormWrapper, this._options, this._globalOptions, this._l10n, this._version);
                break;
            case "PAYON":
                paymentFormResult = new PayonPaymentForm(this._paymentFormWrapper, this._options, this._l10n);
                break;
            case "PAYONWITHPCIPROXY":
                paymentFormResult = new PayonWithPciProxyPaymentForm(this._paymentFormWrapper, this._options, this._globalOptions, this._l10n, this._version);
                break;
            case "PAYPAL":
                paymentFormResult = new PayPalPaymentForm(this._paymentFormWrapper, this._options, this._l10n);
                break;
            default:
                let errorMessage = "Payment provider cannot be resolved. Try to enable other payment providers, configure payment provider settings for the program and/or deactivate payment options that are not supported by the current configuration.\n" +
                    "Specified payment option codes: " +
                    JSON.stringify(this._options.paymentOptionCodes) +
                    "\n" +
                    "Supported payment option codes by enabled payment providers:\n";
                this._globalOptions.getSupportedPaymentProviderPaymentOptions().forEach(provider => {
                    errorMessage = errorMessage + provider.code + ": " + JSON.stringify(provider.paymentOptionCodes) + "\n";
                });
                throw new Error(errorMessage);
        }
        this._paymentFormDisposeCallback = () => paymentFormResult.dispose();
    }
}

;// CONCATENATED MODULE: ./src/ts/user-agreement/user-agreement.ts

class UserAgreement {
    constructor(apiHelper, l10n, target, options) {
        this._viewState = {
            userAgreementReference: null,
            text: null,
            isLoaded: false,
            isLoading: false,
            isAccepted: false
        };
        if (!(target instanceof HTMLElement)) {
            throw "Invalid target.";
        }
        if (!options.programCode) {
            throw "Program Code parameter is required.";
        }
        if (!options.mode) {
            throw "Mode parameter is required.";
        }
        if (!options.financialInstitutionName) {
            throw "Financial Institution Name parameter is required.";
        }
        this._target = target;
        this._options = options;
        this._apiHelper = apiHelper;
        this._l10n = l10n;
        this._agreementWrapperElement = document.createElement("div");
        this._agreementTextElement = document.createElement("div");
        this._headerElement = document.createElement("div");
        this._contentElement = document.createElement("div");
        this._footerElement = document.createElement("div");
        this._loaderElement = document.createElement("div");
        this._loaderInnerElement = document.createElement("div");
        this._captionElement = document.createElement("span");
        this._downloadAgreementTextElement = document.createElement("a");
        this._backButtonElement = document.createElement("button");
        this._checkBoxFormGroupElement = document.createElement("div");
        this._agreeCheckBoxWrapperElement = document.createElement("div");
        this._agreeCheckBoxLabelElement = document.createElement("label");
        this._agreeCheckBoxElement = document.createElement("input");
        this._agreeCheckBoxTextElement = document.createElement("span");
        this._agreeCheckBoxErrorLabelElement = document.createElement("span");
        this._acceptButtonElement = document.createElement("button");
    }
    initialize() {
        this._render();
        this._show();
    }
    _updateViewState(newViewState) {
        this._viewState = {
            ...this._viewState,
            ...newViewState
        };
        if (this._viewState.isLoading) {
            this._agreementWrapperElement.classList.add("kc-user-agreement-loading");
        }
        else {
            this._agreementWrapperElement.classList.remove("kc-user-agreement-loading");
        }
        if (this._viewState.isLoaded) {
            if (this._viewState.isAccepted) {
                this._acceptButtonElement.disabled = true;
            }
            else {
                this._acceptButtonElement.disabled = false;
            }
            this._agreementWrapperElement.classList.add("kc-user-agreement-loaded");
        }
        else {
            this._acceptButtonElement.disabled = true;
            this._agreementWrapperElement.classList.remove("kc-user-agreement-loaded");
        }
    }
    _back() {
        this._updateViewState({
            isAccepted: false
        });
        if (typeof this._options.onBack === "function") {
            this._options.onBack.call(null);
        }
    }
    _accept() {
        if (!this._viewState.isLoaded) {
            throw new Error("User agreement has to be loaded before accepting.");
        }
        this._updateViewState({
            isAccepted: true
        });
        if (typeof this._options.onAccept === "function") {
            this._options.onAccept.call(null, this._viewState.userAgreementReference);
        }
    }
    _load(formatType) {
        return this._apiHelper.get("userAgreement", this._apiHelper.createRequestObject({
            culture: this._l10n.localeOrDefault(),
            programCode: this._options.programCode,
            formatType: formatType || null
        }));
    }
    _download() {
        this._load("PDF").complete({
            success: data => {
                Utils.saveFile(data.fileData, this._options.fileName && this._options.fileName.length > 0 ? this._options.fileName : "user-agreement.pdf", "application/pdf");
            }
        });
    }
    _show() {
        if (this._viewState.isLoading) {
            return;
        }
        this._agreementTextElement.innerHTML = "";
        this._updateViewState({
            isLoaded: false,
            isLoading: true,
            isAccepted: false
        });
        this._load().complete({
            success: data => {
                this._updateViewState({
                    userAgreementReference: data.userAgreementReference,
                    text: data.text,
                    isLoaded: true,
                    isLoading: false
                });
                // data.text response property contains HTML markup be design and should be rendered without encoding.
                this._agreementTextElement.innerHTML = data.text;
                if (typeof this._options.onLoad === "function") {
                    this._options.onLoad.call(null);
                }
            },
            error: data => {
                this._updateViewState({
                    isLoading: false
                });
                if (typeof this._options.onError === "function") {
                    this._options.onError.call(null, data.responseDescription, data);
                }
            }
        });
    }
    _render() {
        this._agreementWrapperElement.className = "kc-user-agreement";
        this._target.appendChild(this._agreementWrapperElement);
        this._headerElement.className = "kc-user-agreement-header";
        this._agreementWrapperElement.appendChild(this._headerElement);
        this._contentElement.className = "kc-user-agreement-content";
        this._agreementWrapperElement.appendChild(this._contentElement);
        this._footerElement.className = "kc-user-agreement-footer";
        this._agreementWrapperElement.appendChild(this._footerElement);
        this._loaderElement.className = "loader";
        this._agreementWrapperElement.appendChild(this._loaderElement);
        this._loaderInnerElement.className = "loader-inner";
        this._loaderElement.appendChild(this._loaderInnerElement);
        this._captionElement.className = "kc-user-agreement-caption";
        this._headerElement.appendChild(this._captionElement);
        this._agreementTextElement.className = "kc-user-agreement-text";
        this._agreementTextElement.appendChild(document.createTextNode(""));
        this._contentElement.appendChild(this._agreementTextElement);
        this._downloadAgreementTextElement.className = "kc-user-agreement-text-download";
        this._downloadAgreementTextElement.appendChild(document.createTextNode(this._l10n.translate("user_agreement_widget_lnk_download")));
        this._contentElement.appendChild(this._downloadAgreementTextElement);
        if (Utils.detectBrowser(navigator.userAgent) === "safari") {
            this._load("PDF").complete({
                success: data => {
                    this._downloadAgreementTextElement.href = `data:application/pdf;base64,${data.fileData}`;
                    this._downloadAgreementTextElement.target = "_blank";
                    this._downloadAgreementTextElement.style.visibility = "visible";
                }
            });
            this._downloadAgreementTextElement.style.visibility = "hidden";
        }
        else {
            this._downloadAgreementTextElement.href = "#";
            this._downloadAgreementTextElement.onclick = event => {
                this._download();
                event.preventDefault();
            };
        }
        this._backButtonElement.type = "button";
        this._backButtonElement.className = "kc-button kc-user-agreement-back-button";
        this._backButtonElement.appendChild(document.createTextNode(this._l10n.translate("user_agreement_widget_mode_btn_back")));
        this._backButtonElement.onclick = () => this._back();
        this._footerElement.appendChild(this._backButtonElement);
        this._checkBoxFormGroupElement.className = "form-group";
        this._footerElement.appendChild(this._checkBoxFormGroupElement);
        this._agreeCheckBoxWrapperElement.className = "checkbox";
        this._checkBoxFormGroupElement.appendChild(this._agreeCheckBoxWrapperElement);
        this._agreeCheckBoxWrapperElement.appendChild(this._agreeCheckBoxLabelElement);
        this._agreeCheckBoxElement.type = "checkbox";
        this._agreeCheckBoxElement.name = "isAgree";
        this._agreeCheckBoxElement.setAttribute("data-val", "true");
        this._agreeCheckBoxElement.setAttribute("data-rule-required", "true");
        this._agreeCheckBoxElement.setAttribute("data-msg-required", this._l10n.translate("user_agreement_widget_agree_err_txt").replace("{0}", this._options.financialInstitutionName));
        this._agreeCheckBoxLabelElement.appendChild(this._agreeCheckBoxElement);
        this._agreeCheckBoxTextElement.textContent = this._l10n.translate("user_agreement_widget_mode_chb_agree").replace("{0}", this._options.financialInstitutionName);
        this._agreeCheckBoxLabelElement.appendChild(this._agreeCheckBoxTextElement);
        this._agreeCheckBoxErrorLabelElement.className = "help-block error field-validation-valid";
        this._agreeCheckBoxErrorLabelElement.setAttribute("data-valmsg-replace", "true");
        this._agreeCheckBoxErrorLabelElement.setAttribute("data-valmsg-for", "isAgree");
        this._checkBoxFormGroupElement.appendChild(this._agreeCheckBoxErrorLabelElement);
        const acceptButtonText = this._options.mode === "REPEATED" ? this._l10n.translate("user_agreement_accept_button") : this._l10n.translate("user_agreement_widget_mode1_btn_close");
        this._acceptButtonElement.type = "button";
        this._acceptButtonElement.className = "kc-button kc-button-primary kc-user-agreement-accept-button";
        this._acceptButtonElement.appendChild(document.createTextNode(acceptButtonText));
        this._acceptButtonElement.onclick = () => this._accept();
        this._footerElement.appendChild(this._acceptButtonElement);
    }
}

;// CONCATENATED MODULE: ./src/ts/cwPaymentForm.ts






class CWWebSdkStartup {
    constructor() {
        this.version = "9.0.0";
        const version = this.version;
        const l10n = new L10n();
        const globalOptions = (this._globalOptions = new GlobalOptions(l10n));
        const apiHelper = new ApiHelper(this._globalOptions);
        this.UserAgreement = function (target, options) {
            const userAgreement = new UserAgreement(apiHelper, l10n, target, options);
            userAgreement.initialize();
        };
        this.PaymentConfirmation = function (form, options) {
            const paymentConfirmation = new PaymentConfirmation(form, options);
            paymentConfirmation.initialize();
        };
        this.PaymentForm = function (target, options) {
            const paymentForm = new PaymentForm(target, options, globalOptions, l10n, version);
            return {
                dispose: () => paymentForm.dispose()
            };
        };
    }
    onReady(callback) {
        document.addEventListener("DOMContentLoaded", () => callback());
    }
    initialize(options) {
        this._globalOptions.update(options);
    }
}
/* harmony default export */ const cwPaymentForm = (new CWWebSdkStartup());

window.cw = __webpack_exports__["default"];
/******/ })()
;